/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 13.04.2010
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <m8_128.h>
#include <delay.h>
// Standard Input/Output functions
#include <stdio.h>
                       

void USART_Transmit( unsigned char data )
{
        while ( !( UCSRA & 0x20) );
        UDR = data;                                               
}
      

interrupt[EXT_INT0] int0_interrupt()
{
}           
unsigned char  key1 = 0;
unsigned char  key2 = 0; 
void main(void)
{
PORTB=b_0011_1000;
DDRB=b_0000_0000;

PORTC=b_0000_0001;
DDRC=b_0001_1100;

PORTD=b_0000_0100;
DDRD=b_0000_1000;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off        
//BIT 7: enable sleep mode
//BIT [6, 4] : select sleep mode ( 010 - power down )
MCUCR = b_1010_0000;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: Off
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x08;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;    

//bit 3 disable Pull-Ups on ALL PINs
SFIOR=0x00; 
SPCR = 0;         
        while (1) 
        {    
                                                                     
        if(  key1 == 0 && key2 == 0 )     
        {
                           
                
                
                PORTD.3 = 0;                 
                PORTC.2 = 0; 
                PORTC.3 = 0; 
                PORTC.4 = 0;
                
                #asm("SLEEP");                
                PORTD.3 = 1;
                                                             
                #asm("NOP");
                #asm("NOP");
                #asm("NOP");
                #asm("NOP");
                #asm("NOP");
                #asm("NOP");
                #asm("NOP");
                #asm("NOP");
                #asm("NOP");
                #asm("NOP");         
        }
                    
                key1 = 0;
                key2 = 0;     
                
                PORTC = 0x19; 
                if( PINB.3 == 0x00 )                           
                        key1 = key1|1;
                if( PINB.4 == 0x00 )
                        key1 = key1|8;
                if( PINB.5 == 0x00 )
                        key1 = key1|64;
                if( PINC.0 == 0x00)
                        key2 |= 2;
                
                
                PORTC=0x15;
                if( PINB.3  == 0x00 )                           
                        key1 = key1|2;
                if( PINB.4  == 0x00 )
                        key1 = key1|16;
                if( PINB.5  == 0x00 )
                        key1 = key1|128;
                if( PINC.0  == 0x00)
                        key2 |= 4;    
                        
                PORTC=0xD; 
                if( PINB.3  == 0x00 )                           
                        key1 |= 4;
                if( PINB.4  == 0x00 )
                        key1 |= 32;
                if( PINB.5  == 0x00 )
                        key2 |= 1;
                if( PINC.0  == 0x00)
                        key2 |= 8;                                                                                                
                               
              USART_Transmit('B');                                                                                        
              USART_Transmit('E');
              USART_Transmit('G');
              USART_Transmit('I');
              USART_Transmit('N');
              USART_Transmit(key1);
              USART_Transmit(~key1);
              USART_Transmit(key2); 
              USART_Transmit(~key2); 
              while ( !( UCSRA & 0x40) );                                      
        }   

}
