/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.9 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 20.04.2010
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <m8_128.h>
#include <delay.h>  

// Standard Input/Output functions
#include <stdio.h>

// Declare your global variables here             
        
#define LED_OFF b_0000_0000
#define LED_0 b_1100_0000
#define LED_1 b_1111_1001
#define LED_2 b_1010_0100
#define LED_3 b_1011_0000
#define LED_4 b_1001_1001
#define LED_5 b_1001_0010
#define LED_6 b_1000_0010
#define LED_7 b_1111_1000
#define LED_8 b_1000_0000
#define LED_9 b_1001_0000

#define TIMER_ADDON 19
char TimerValue[12] = {0};
interrupt[TIM0_OVF] timer_ovf()
{                 
        if( TimerValue[0] > 0 ) { TimerValue[0]--; if( TimerValue[0] == 0 ) PORTB.0 = 0; }
        if( TimerValue[1] > 0 ) { TimerValue[1]--; if( TimerValue[1] == 0 ) PORTB.1 = 0; }
        if( TimerValue[2] > 0 ) { TimerValue[2]--; if( TimerValue[2] == 0 ) PORTB.2 = 0; }
        if( TimerValue[3] > 0 ) { TimerValue[3]--; if( TimerValue[3] == 0 ) PORTB.3 = 0; }
        if( TimerValue[4] > 0 ) { TimerValue[4]--; if( TimerValue[4] == 0 ) PORTB.4 = 0; }
        if( TimerValue[5] > 0 ) { TimerValue[5]--; if( TimerValue[5] == 0 ) PORTB.5 = 0; }
        if( TimerValue[6] > 0 ) { TimerValue[6]--; if( TimerValue[6] == 0 ) PORTB.6 = 0; }
        if( TimerValue[7] > 0 ) { TimerValue[7]--; if( TimerValue[7] == 0 ) PORTB.7 = 0; }
        if( TimerValue[8] > 0 ) { TimerValue[8]--; if( TimerValue[8] == 0 ) PORTC.0 = 0; }
        if( TimerValue[9] > 0 ) { TimerValue[9]--; if( TimerValue[9] == 0 ) PORTC.1 = 0; }
        if( TimerValue[10] > 0 ){TimerValue[10]--; if( TimerValue[10]== 0 ) PORTC.2 = 0; }
        if( TimerValue[11] > 0 ){TimerValue[11]--; if( TimerValue[11]== 0 ) PORTC.3 = 0; }
        
        
}

void show_res_val_l(unsigned char value)
{                          

        if( (value)&0x1 )       PORTB.0 = TimerValue[0] =  TIMER_ADDON;
        if( (value>>1)&0x1)     PORTB.1 = TimerValue[1] =  TIMER_ADDON;  
        if( (value>>2)&0x1)     PORTB.2 = TimerValue[2] =  TIMER_ADDON;  
        if( (value>>3)&0x1)     PORTB.3 = TimerValue[3] =  TIMER_ADDON;  
        if( (value>>4)&0x1)     PORTB.4 = TimerValue[4] =  TIMER_ADDON;  
        if( (value>>5)&0x1)     PORTB.5 = TimerValue[5] =  TIMER_ADDON;  
        if( (value>>6)&0x1)     PORTB.6 = TimerValue[6] =  TIMER_ADDON;  
        if( (value>>7)&0x1)     PORTB.7 = TimerValue[7] =  TIMER_ADDON;  
}                  

unsigned char USART_Receive( void )
{
        while ( !(UCSRA & 0x80) );
        return UDR;
}       

void show_res_val_h(unsigned char value)
{                                          
        if((value)&0x1)         PORTC.0 =  TimerValue[8] = TIMER_ADDON;
        if((value>>1)&0x1)      PORTC.1 =  TimerValue[9] = TIMER_ADDON;
        if((value>>2)&0x1)      PORTC.2 =  TimerValue[10] = TIMER_ADDON;
        if((value>>3)&0x1)      PORTC.3 =  TimerValue[11] = TIMER_ADDON;        
}      

unsigned char command[4] = {0};
void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0 
PORTB=0x00;
DDRB=0xFF;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out 
// State6=T State5=T State4=T State3=0 State2=0 State1=0 State0=0 
PORTC=0x00;
DDRC=0x0F;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0 |= (1<<CS02);
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=(1<<TOIE0);

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: Off
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x10;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x19;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;
PORTB = LED_OFF;
#asm("sei");
while (1)
      {    
      
                 

      if( USART_Receive() == 'B' && USART_Receive() == 'E' && USART_Receive() == 'G' && USART_Receive() == 'I' &&
       USART_Receive() == 'N')
       {
              
              command[0] = USART_Receive();
              command[1] = USART_Receive();
              command[2] = USART_Receive();
              command[3] = USART_Receive(); 
              if( command[0] & 0x01 ) PORTB = LED_1;
              else if( command[0] & 0x02 ) PORTB = LED_2;
              else if( command[0] & 0x04 ) PORTB = LED_3;
              else if( command[0] & 0x08 ) PORTB = LED_4;
              else if( command[0] & 0x10 ) PORTB = LED_5;
              else if( command[0] & 0x20 ) PORTB = LED_6;
              else if( command[0] & 0x40 ) PORTB = LED_7;
              else if( command[0] & 0x80 ) PORTB = LED_8;
              else if( command[2] & 0x01 ) PORTB = LED_9;
                       
          /*    if( command[0] == ~command[1] && command[2] == ~command[3]  )                        
              {
                show_res_val_l(command[0]);              
                show_res_val_h(command[2]);                 
              }       */
       }
      };
}
